Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2321 by niro, Fri Jan 3 13:15:44 2014 UTC revision 2493 by niro, Wed Jan 8 12:27:04 2014 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/bash
2    # $Id$
3  #  #
4  # $Header: /home/cvsd/alx-cvs/alx-src/alxinstall-ng/bin/alxinstall-ng.sh,v 1.15 2008-06-28 00:37:45 niro Exp $  # Simple Installation Script
5  #  # merged from alxinstall-ng and mcore-installer
 # AutoSta_LX Installation Script  
6  #  #
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
 # <rogalla@augusta-bochum.de>  
 #  
 #  
 # Install Navigation Gui  
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # setup locales
11  source /mnt/cdrom/system/images.conf  TEXTDOMAIN=installer
   
 #Includes  
 source /usr/lib/alxinstall-ng/functions/findhdd.sh > /dev/null  
 ### bugfix ###############################  
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
   
 ### System/Config Version  
 VERSION="%VERSIONTAG%"  
 TITLE="alxinstall-ng - ${VERSION}"  
12    
13  CDPATH="/mnt/cdrom"  # include dir
14  INSTALLPATH="/mnt/magellan"  INSTALLER_LIBDIR="%LIBDIR%"
15    
16  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
17    # -> now in images.conf
18  CURRENTLINE=0  CURRENTLINE=0
 #TOTALLINES=11072 # -> now in images.conf  
   
 # standard kernel opts  
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
 GRUBLEGACYOPTS=""  
 GRUB2OPTS=""  
   
 # fdisk options  
 FDISKPARTIONBELOW256MB=0  
   
 # default specialdevices  
 SPECIALDEVICE=""  
 FORMFACTOR="desktop"  
   
 # target filesystem  
 FORMAT_FILESYSTEM="ext4"  
   
 #################################################  
 #  DIALOG BOXEN #  
 #################################################  
19    
20  die()  die()
21  {  {
22   ERROR=$1   echo "Error: $@"
  RETVAL=$?  
  dialog_install_failure  
23   exit 1   exit 1
24  }  }
25    
26  dialog_warning()  # load common includes
27  {  for inc in %SYSCONFDIR%/installer.conf \
28   dialog \   ${INSTALLER_LIBDIR}/functions/common.sh \
29   --backtitle "${TITLE}" \   ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
30   --colors \   ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
31   --defaultno \   ${INSTALLER_LIBDIR}/functions/bootloader.sh \
32   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
33   Diese Festplatte wird unwiederruflich geloescht werden.\n\n\   ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
34   Soll ich wirklich fortfahren ?" 10 70  do
35   RES=$?   if [ -e ${inc} ]
  if [[ ${RES} -eq 1 ]]  
  then  
  clear  
  echo "Der Vorgang wurde abgebrochen."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
 }  
   
 dialog_setup_system_menu()  
 {  
  local i  
   
  i=$(dialog \  
  --backtitle "${TITLE}" \  
  --title "[ Festplatten Partitionierung ]" \  
  --cancel-label "Abbrechen" \  
  --ok-label "Weiter" \  
  --stdout \  
  --colors \  
  --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \  
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case "${i}" in  
  "1") run_install_auto ;;  
          "2") run_install_normal ;;  
  "3") run_install_flash ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local i  
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
   
  [[ ! -z ${installdevs} ]] && installdevs=""  
   
  echo "dialog \\"  > ${hwtmp}  
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
   
  if [[ ! -z ${scsidisks} ]]  
  then  
  for i in ${scsidisks}  
  do  
  if [[ ${i} != ${cdromdev} ]]  
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
  done  
  fi  
   
  if [[ ! -z ${idedisks} ]]  
  then  
  for i in ${idedisks}  
  do  
  if [[ ${i} != ${cdromdev} ]]  
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
  done  
  fi  
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}  
  fi  
   
  echo " \" 14 70" >> ${hwtmp}  
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manuell  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
36   then   then
37   dialog \   source "${inc}"
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
38   else   else
39     die "'${inc}' not found"
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
  fi  
40   fi   fi
41  }  done
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
42    
43   echo "dialog \\" > /tmp/hddtmp.sh  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
44   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  # -> now in images.conf
45   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  CDIMAGENAME=""
46   echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  TOTALLINES=""
47   echo "--stdout \\" >> /tmp/hddtmp.sh  CURRENTLINE=0
48   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  if [ -e /mnt/cdrom/system/images.conf ]
49    then
50     source /mnt/cdrom/system/images.conf
51     # check if all required variables are set
52     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
53     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
54    else
55     die "/mnt/cdrom/system/images.conf not found"
56    fi
57    
58   for i in ${installdevs}  ### System/Config Version
59   do  VERSION="%VERSIONTAG%"
60   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  TITLE="${DEFAULT_TITLE} - ${VERSION}"
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
61    
62   chmod a+x /tmp/hddtmp.sh  # some sane defaults
63   HDD="$(/tmp/hddtmp.sh)"  CDROOT="${DEFAULT_CDROOT}"
64   RES=$?  INSTALLROOT="${DEFAULT_INSTALLROOT}"
65   [[ ${RES} -eq 1 ]] && return 1  KERNELPKG="${DEFAULT_KERNELPKG}"
66   if [[ ${RES} -eq 0 ]]  KERNELOPTS="${DEFAULT_KERNELOPTS}"
67   then  GRUBLEGACYOPTS=""
68   dialog_setup_hdd_info_auto  GRUB2OPTS=""
69   dialog_setup_hdd_create_partitions  FDISKPARTIONBELOW256MB=0
70   setup_hdd_partitions_auto  SPECIALDEVICE=""
71   fi  FORMFACTOR="${DEFAULT_FORMFACTOR}"
72   fi  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
 }  
73    
 dialog_setup_hdd_create_partitions()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
74    
75  dialog_setup_hdd_format()  ### helper scripts ###
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
76    
77  dialog_install_settings()  trap_exit()
78  {  {
79   dialog \   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80   --backtitle "${TITLE}" \   is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81   --infobox "Speichere System-Einstellungen ..." 3 70   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82  }   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84    
85  dialog_install_system_image()   echo $"Installation aborted."
86  {   exit 1
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
87  }  }
88    
89  dialog_install_meter()  install_meter()
90  {  {
91   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
92   do   do
# Line 384  dialog_install_meter() Line 99  dialog_install_meter()
99   return 0   return 0
100  }  }
101    
102    mount_rootfs()
 dialog_install_bootsector()  
103  {  {
104   dialog \   local retval
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
105    
106  dialog_install_successful()   if is_mounted --location "${INSTALLROOT}"
107  {   then
108   dialog \   echo $"${INSTALLROOT} already mounted" >&2
109   --backtitle "${TITLE}" \   else
110   --colors \   mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive'${ROOTHDD}' -> '${INSTALLROOT}'"
111   --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81   fi
112     [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
113  }  }
114    
115  dialog_install_failure()  umount_rootfs()
116  {  {
117   dialog \   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
118   --backtitle "${TITLE}" \   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
119  }  }
120    
121  dialog_main()  install_do_reboot()
122  {  {
123   METHOD=0   reboot
   
  while [[ ${METHOD} -le 2 ]]  
  do  
  METHOD=$(dialog \  
  --backtitle "${TITLE}" \  
  --no-cancel \  
  --ok-label "Weiter" \  
  --stdout \  
  --menu "Konfiguration" 14 70 5 \  
  "1" "AutoSta_LX installieren" \  
  "2" "Uebersicht gefundener Laufwerke" \  
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  case ${METHOD} in  
          "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
124  }  }
125    
 #################################################  
 # Install Komandos #  
 #################################################  
126  run_hardware_detection()  run_hardware_detection()
127  {  {
128   local hwinfo   local hwinfo
129    
130   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
131    
132   # check for special devices/clients:   ## check for special devices/clients:
133   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
134   local removable=0   #local removable=0
135   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
136   then   #then
137   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
138   do   #do
139   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
140   then   #then
141   removable=1   #removable=1
142   fi   #fi
143   done   #done
144     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
145   # only add this for grub legacy, grub2 detect these settings on its own  
146   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
147   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
148   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
149   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
150   export SPECIALDEVICE="zotac_nvidia"   #then
151   else   #export SPECIALDEVICE="zotac_nvidia"
152   export SPECIALDEVICE="zotac_intel"   #else
153   fi   #export SPECIALDEVICE="zotac_intel"
154   fi   #fi
155     #fi
156    
157   # check for special devices/clients:   # check for special devices/clients:
158   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 500  run_hardware_detection() Line 181  run_hardware_detection()
181   fi   fi
182  }  }
183    
184  hdd_size_below_256mb()  run_hardware_detection_disks()
185  {  {
186   local hdd="$1"   local bootdev
  local size  
  local retval  
  [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"  
187    
188   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # all disks but exclude ramdisks
189   if [[ ${size} -le 257000000 ]]   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
190     # remove the boot device from ALL_DISKS if it was an usbstick
191     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
192   then   then
193   retval="0"   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
194   else   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  retval="1"  
195   fi   fi
196     export ALL_CDROMS="$(get_hwinfo cdrom)"
  return "${retval}"  
197  }  }
198    
199  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
200  {  {
201   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
202    
203     # sanity check - should not happen
204     if is_mounted --device "${ROOTHDD}"
205     then
206     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
207     umount "${ROOTHDD}"
208     fi
209    
210   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
211   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
212   then   then
213   if hdd_size_below_256mb ${HDD}   if device_minimum_size "${HDD}" 256
214   then   then
215   FDISKPARTIONBELOW256MB=1   FDISKPARTIONBELOW256MB=1
216   else   else
# Line 534  setup_hdd_partitions_auto() Line 219  setup_hdd_partitions_auto()
219   fi   fi
220    
221   ## delete disk   ## delete disk
222   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
223    
224   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
225   then   then
# Line 580  EOF Line 265  EOF
265   fi   fi
266  }  }
267    
268  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
269  {  {
270   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
271     SWAPHDD=""
272   ## hdds partitionieren manuell   BOOTHDD=""
273   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
274  }  }
275    
276  setup_hdd_format()  setup_hdd_format()
277  {  {
278   mkswap ${SWAPHDD} || die   # sanity check - should not happen
279   mke2fs -j -q ${BOOTHDD} || die   if is_mounted --device "${ROOTHDD}"
280   mke2fs -j -q ${ROOTHDD} || die   then
281  }   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
282     umount "${ROOTHDD}"
283  setup_hdd_format_flash()   fi
 {  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 install_mount_rootfs()  
 {  
  swapon ${SWAPHDD} || die  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
284    
285  install_mount_rootfs_flash()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
286  }  }
287    
288  install_system_image()  install_system_image()
289  {  {
290   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   pushd ${INSTALLROOT} > /dev/null
291     tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
292     popd > /dev/null
293  }  }
294    
295  install_bootsector_chroot()  install_system_settings()
296  {  {
297   local my_roothdd   local CONFIG
  local grubconf=${INSTALLPATH}/boot/grub/grub.conf  
  local grub2conf=/boot/grub/grub.cfg  
   
  # check for grub2  
  if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]  
  then  
  # needed by grub-mkconfig on the first run  
  if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]  
  then  
  install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die  
  fi  
   
  # set kernelopts  
  if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]  
  then  
  sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die  
  else  
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die  
  echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die  
   
  # grub-legacy  
  else  
  ### grubconf schreiben  
  source ${INSTALLPATH}/boot/kernelversion  
298    
299   #for alx only   # write fstab
300   if [ -e ${INSTALLPATH}/etc/alx_version ]   CONFIG="${INSTALLROOT}/etc/fstab"
301   then   clearconfig
302   OLD_ALXVER="${ALXVER}"   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
303   source ${INSTALLPATH}/etc/alx_version   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
304   KRNVER="ALX-${ALXVER}"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  ALXVER="${OLD_ALXVER}"  
  fi  
   
  [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  
  [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
305    
306   # uuid support   # install network config skeleton
307   if is_uuid_supported   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
308   then   clearconfig
309   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"   addconfig 'ONBOOT="yes"'
310   else   addconfig 'NETWORKING="dhcp"'
  my_roothdd="${ROOTHDD}"  
  fi  
311    
312   : > ${grubconf} || die   # intel framebuffer quirk
313   echo "default 0" >> ${grubconf} || die   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
314   echo "timeout 3" >> ${grubconf} || die   then
315   # using current root password   if [ -e /proc/fb ]
  echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die  
   
  echo  >> ${grubconf} || die  
  echo "# normal boot" >> ${grubconf} || die  
  echo "title ${KRNVER}" >> ${grubconf} || die  
  echo "root (hd0,0)" >> ${grubconf} || die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die  
  if is_initrd_supported  
316   then   then
317   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
318     then
319     fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
320     if [[ ${fbdev} != 0 ]]
321     then
322     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
323     fi
324     fi
325   fi   fi
326     fi
327    }
328    
  echo >> ${grubconf} || die  
  echo "# admin boot" >> ${grubconf} || die  
  echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die  
  echo "lock"  >> ${grubconf} || die  
  echo "root (hd0,0)" >> ${grubconf} || die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die  
  fi  
329    
330   echo >> ${grubconf} || die  ### installer dialogs ###
  echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die  
  echo "lock"  >> ${grubconf} || die  
  echo "root (hd0,0)" >> ${grubconf} || die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die  
  fi  
331    
332   # bootsector schreiben chrooted schreiben (lfs/magellan)  dialog_die()
333   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF  {
334  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   ERROR="$1"
335  root (hd0,0)   RETVAL="$?"
336  setup (hd0)   dialog_install_failure
337  quit   exit 1
338  EOF  }
 exit 0  
 CHROOTEOF  
  fi  
339    
340   ## enters chroot  dialog_warning()
341   mount -t proc proc ${INSTALLPATH}/proc  {
342   mount -t sysfs sysfs ${INSTALLPATH}/sys   local retval
  mount -o bind /dev ${INSTALLPATH}/dev  
  chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLPATH}/proc  
  umount ${INSTALLPATH}/sys  
  umount ${INSTALLPATH}/dev  
  rm ${INSTALLPATH}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
 install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
343    
344   if [[ ${FORMFACTOR} = laptop ]]   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
345     retval=$?
346     if [[ ${retval} -eq 1 ]]
347   then   then
348   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   clear
349     echo $"The process was aborted."
350     exit 1
351   fi   fi
352    }
353    
  # install an appropriate uvesafb.conf  
  install -d ${INSTALLPATH}/etc/modprobe.d || die  
  echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die  
   
  # install an appropriate viafb.conf  
  echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die  
   
  # install an appropriate i810fb.conf  
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die  
   
  cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF  
 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  
 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  
 exit 0  
 CHROOTEOF  
354    
355   ## enters chroot  ### installer tasks ###
  mount -t proc proc ${INSTALLPATH}/proc  
  mount -t sysfs sysfs ${INSTALLPATH}/sys  
  mount -o bind /dev ${INSTALLPATH}/dev  
  chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLPATH}/proc  
  umount ${INSTALLPATH}/sys  
  umount ${INSTALLPATH}/dev  
  rm ${INSTALLPATH}/root/.installrc  
 }  
356    
357  is_uuid_supported()  task_setup_system_menu()
358  {  {
359   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   local mode
360     local retval
361    
362     mode="$(dialog_setup_system_menu)"
363     retval=$?
364     [[ ${retval} -eq 1 ]] && return 1
365     if [[ ${retval} -eq 0 ]]
366   then   then
367   # only detect uuids if supported   case "${mode}" in
368   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   "1") run_install_auto ;;
369   then   "2") run_install_normal ;;
370   return 0   "") task_setup_system_menu;;
371   fi   esac
372   fi   fi
   
  return 1  
373  }  }
374    
375  get_uuid()  task_hardware_detection()
376  {  {
377   local UUID   local message
  local SEC_TYPE  
  local TYPE  
378    
379   local dev="$1"   run_hardware_detection_disks
  [[ -z ${dev} ]] && die "no dev given"  
380    
381   # check if given device is already an UUID   message+=$"Harddrives:\n"
382   if [[ ${dev/UUID=/}x != ${dev}x ]]  
383     if [[ ! -z ${ALL_DISKS} ]]
384   then   then
385   eval "${dev}"   for i in ${ALL_DISKS}
386   else   do
387   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   message+="\Z3${i}\Zn "
388     done
389     message+="\n"
390   fi   fi
  echo "${UUID}"  
 }  
391    
392  install_system_settings()   if [[ ! -z ${ALL_CDROMS} ]]
 {  
  # schreibe fstab  
  if is_uuid_supported  
393   then   then
394   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   message+="\n"
395   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   message+=$"Optical disk drives:\n"
396   else   for i in ${ALL_CDROMS}
397   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   do
398   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die   message+="\Z3${i}\Zn"
399     done
400     message+="\n"
401   fi   fi
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
   
  # install network config skeleton  
  install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die  
402    
403   # intel framebufer quirk   # other devices
404   if [[ -e /proc/fb ]]   run_hardware_detection
405     case "${SPECIALDEVICE}" in
406     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
407     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
408     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
409     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
410     esac
411     if [[ ${FORMFACTOR} = laptop ]]
412   then   then
413   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
  then  
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die  
  fi  
  fi  
414   fi   fi
415    
416     messagebox -y 12 -h $"Detected hardware:" "${message}"
417  }  }
418    
419  install_system_settings_flash()  task_setup_hdd_partitions_manual()
420  {  {
421   # schreibe fstab   local i
422   if is_uuid_supported   local retval
423    
424     if [[ -z ${ALL_DISKS} ]]
425   then   then
426   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die   dialog_no_harddrive_found
427     exit 1
428   else   else
429   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die   HDD=$(dialog_select_target_harddrive)
430     retval=$?
431     [[ ${retval} -eq 1 ]] && return 1
432     if [[ ${retval} -eq 0 ]]
433     then
434     dialog_setup_hdd_info
435     setup_hdd_partitions_manual
436     fi
437   fi   fi
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
438  }  }
439    
440  install_umount_rootfs()  task_setup_hdd_partitions_auto()
441  {  {
442   cd /   local i
443   umount ${INSTALLPATH}/boot || die   local retval
  umount ${INSTALLPATH} || die  
  swapoff ${SWAPHDD} || die  
 }  
444    
445  install_umount_rootfs_flash()   if [[ -z ${ALL_DISKS} ]]
446  {   then
447   cd /   dialog_no_harddrive_found
448   umount ${INSTALLPATH} || die   exit 1
449     else
450     HDD=$(dialog_select_target_harddrive)
451     retval=$?
452     [[ ${retval} -eq 1 ]] && return 1
453     if [[ ${retval} -eq 0 ]]
454     then
455     dialog_setup_hdd_info_auto
456     dialog_setup_hdd_create_partitions
457     setup_hdd_partitions_auto
458     fi
459     fi
460  }  }
461    
462  install_do_reboot()  task_main()
463  {  {
464   reboot   local method=0
465  }   local retval
466    
467  #################################################   while [[ ${method} -le 2 ]]
468  #     Install Ablauf Scripte #   do
469  #################################################   method=$(dialog_main)
470     retval=$?
471     [[ ${retval} -eq 1 ]] && exit 1
472     if [[ ${retval} -eq 0 ]]
473     then
474     case ${method} in
475     "1") task_setup_system_menu ;;
476     "2") task_hardware_detection ;;
477     "3") install_do_reboot ;;
478     "4") /bin/bash --login -i ;;
479     esac
480     fi
481     done
482    }
483    
484  run_install_normal()  run_install_normal()
485  {  {
486   dialog_hardware_detection   task_hardware_detection
487    
488   dialog_setup_hdd_partitions_manuell   task_setup_hdd_partitions_manual
489   dialog_setup_hdd_format   dialog_setup_hdd_format
490   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
491   install_mount_rootfs   mount_rootfs
492   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
493    
494   dialog_install_settings   dialog_install_settings
495   sleep 1   sleep 1
496   install_system_settings   install_system_settings
497   install_initrd_chroot   if is_initrd_supported
498     then
499   dialog_install_bootsector   dialog_install_initrd
500   install_bootsector_chroot   initrd_config
501     initrd_install
502   install_umount_rootfs   fi
  dialog_install_successful  
 }  
   
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
503    
504   dialog_install_bootsector   dialog_install_bootsector
505   install_bootsector_chroot   bootloader_config
506     bootloader_install
507    
508   install_umount_rootfs_flash   umount_rootfs
509   dialog_install_successful   dialog_install_successful
510  }  }
511    
512  run_install_auto()  run_install_auto()
513  {  {
514   dialog_hardware_detection   task_hardware_detection
515    
516   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
517   dialog_setup_hdd_format   dialog_setup_hdd_format
518   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
519   install_mount_rootfs_flash   mount_rootfs
520   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
521    
522   dialog_install_settings   dialog_install_settings
523   sleep 1   sleep 1
524   install_system_settings_flash   install_system_settings
525   install_initrd_chroot   if is_initrd_supported
526     then
527     dialog_install_initrd
528     initrd_config
529     initrd_install
530     fi
531    
532   dialog_install_bootsector   dialog_install_bootsector
533   install_bootsector_chroot   bootloader_config
534     bootloader_install
535    
536   install_umount_rootfs_flash   umount_rootfs
537   dialog_install_successful   dialog_install_successful
538  }  }
539    
540  dialog_main  # set some proper traps
541    trap "trap_exit" SIGINT SIGQUIT
542    
543    task_main
544    
545  exit 0  exit 0

Legend:
Removed from v.2321  
changed lines
  Added in v.2493